package name.panitz.eliza;

/**
  Contains the two necessary methods for determining the 
  logic of the simple GUI framework: Dialogue.
**/
public interface ButtonLogic {
    /**
       The label text on the Button in the GUI.
       
       @return the button label text.
     **/
  String getDescription();

    /**
       Describes how the text in the input field is converted
       into a text for the output field.
       @param x is the text as read from the input field.
       @return the text to be written into the output field.
     **/
  String eval(String x);
}

