package name.panitz.eliza;
import static name.panitz.eliza.LiImpl.cons;
/**
  A simulation of a psycho therapist. 
  This program has been converted from Mark .P. Jones
  Gofer implementation.
**/
public class Eliza implements ButtonLogic  {
  Data data=new Data();
  String prev = "";

  public String getDescription(){
    return "submit";
  }

  public String eval(String s){
    String result = "";	

    if (s.equals(prev)) {
      result = data.repeatMsgs.head();
      data.repeatMsgs.rotate();
    }else {
       Li<String> question  = ListUtil.words(stripPunctuation(s));
       result = answer(question);
    }
    prev = s;
    return result;
  }

  static public String stripPunctuation(String s){
    String result="";
    for (int i=0;i<s.length();i=i+1){
      if (PUNCTUATIONS.indexOf(s.charAt(i))<0){
	    result=result+s.charAt(i);
	   }
    }
    return result;
  }

  static final String PUNCTUATIONS =".,;:?!";

  String answer (Li<String> question){
    return ans(data.respMsgs,question);
  }
  
  String ans(Map<Li<String>,Li<String>> es, Li<String> l){
    Pair<Li<String>,Li<String>> e = es.head();
    Li<String> key = e.fst;
    Li<String> as = e.snd;

    Li<String> rs = replies(key,l)  ;
    if (rs.isEmpty()) return ans(es.tail(),l);
    else {
      as.rotate();
      return makeResponse(as.head(),rs.head());
    }
  }

  public Li<String> replies(Li<String>  key, Li<String> question){ 
    Li<String> result = new LiImpl<String>();
    int keyLength = key.length();

    Li<Li<String>> questionFragments = question.tails();
    Li<Li<String>> matchingFragments
      = questionFragments.filter(new IsPrefixIgnoreCaseFilter(key));

    for (Li<Li<String>> xs=matchingFragments;!xs.isEmpty();xs=xs.tail()){
      result = cons(conjug(question, xs.head().drop(keyLength)),result); 
    }
    return result;
  }

  String conjug(Li<String> q, Li<String> xs){
    Li<String> sel = xs.isEmpty()?q:xs;
    Li<String> result = cons(" ",new LiImpl<String>());
    for (Li<String> ys= sel;!ys.isEmpty();ys= ys.tail()){
      result = cons(data.CONJUGATES.lookup(ys.head(),ys.head()),result);
    }
    return result.reverse().unwords();
  }

  String makeResponse(String cs,String us){
    if (cs.charAt(0)=='?') return cs.substring(1)+us+"?";
    if (cs.charAt(0)=='.') return cs.substring(1)+us+".";
    return cs;
  }
}
