package name.panitz.eliza;

/**
  An abstract description of a simple linked list.
**/
public interface Li<a> {
    /**
       Tests, if the list contains some element.
       @return true if no element is contained in the list.
     **/
  public boolean isEmpty();

    /**
       Returns the first element of this list.
       @return from element.
     **/
  public a head();
    /**
       Returns the list after the first element has been skipped.
       @return the tail (rest) of the list, which follows first element.
     **/
  public Li<a> tail();

////////////////////////////////////////////////////////////////////

    /**
       @return the number of elements in this list.
    **/
  int length();


    /**
       Appends two list.
       Thus not modify this or that.
       @param that list which is appended  to this for creating result
       @return a new list which is the concatenation of this with that.
    **/
  Li<a> append(Li<a> that);

    /**
       Just another name for method <tt>append</tt>

       @return a new list which is the concatenation of this with that.
    **/
  Li<a> concat(Li<a> that);

    /**
       Creates a list with all elements that fullfill the condition.

       @param cond Condition to test if element is to be in result list.
       @return list with elements that fullfill condition.
     **/
  Li<a> filter(FilterCondition<a> cond);


  /** 
     Makes a list of lists of all taillists.
     

     example: for the list ("this","is","a","test")
     this produces:
         (("this","is","a","test"),("is","a","test"),("a","test"),("test"))

     @return a list of lists, which contains all list obtained from
       this list through several calls of tail().
    **/
  public Li<Li<a>> tails();

  /** 
    Removes the first i elements from a list.

    @param i a positive number of elements to be skipped
       from the beginning of the list.
    @return this list with i elements dropped by tail calls.
   **/
  public Li<a> drop(int i);


  /**
     Reverses the element order of the list.

     example: ("a","b","c") gets ("c","b","a")

     @return a new list with reversed element order of this list.
   **/
  public Li<a> reverse();

    /**
       Mutates this list, by appending first element as last.
     **/
  abstract public void rotate();


  /** Makes a list to a String adding whitespace between the list elements.

    This is a reverse function to ListUtil.words.

    example: unwords for a list: ("this","is","a","test")
             produces the String: "this is a test"

     @return a string which concatenates the Strings of this list with
          whitespace characters.
  **/
  abstract public String unwords();
}

